package com.twelvemonkeys.io;

import java.io.*;

/**
 * MemoryCacheSeekableStreamTestCase
 * <p/>
 *
 * @author <a href="mailto:harald.kuhr@gmail.com">Harald Kuhr</a>
 * @version $Id: //depot/branches/personal/haraldk/twelvemonkeys/release-2/twelvemonkeys-core/src/test/java/com/twelvemonkeys/io/FileSeekableStreamTestCase.java#1 $
 */
public class FileSeekableStreamTestCase extends SeekableInputStreamAbstractTestCase {
    public FileSeekableStreamTestCase(String name) {
        super(name);
    }

    protected SeekableInputStream makeInputStream(byte[] pBytes) {
        try {
            File temp = File.createTempFile("tm-io-junit", null);
            temp.deleteOnExit();
            OutputStream os = new FileOutputStream(temp);
            try {
                os.write(pBytes);
            }
            finally {
                os.close();
            }
            return new FileSeekableStream(temp);
        }
        catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
}
