package com.twelvemonkeys.util.convert;

/**
 * NumberConverterTestCase
 * <p/>
 *
 * @author <a href="mailto:harald.kuhr@gmail.com">Harald Kuhr</a>
 * @author last modified by $Author: haku $
 * @version $Id: //depot/branches/personal/haraldk/twelvemonkeys/release-2/twelvemonkeys-core/src/test/java/com/twelvemonkeys/util/convert/NumberConverterTestCase.java#1 $
 */
public class NumberConverterTestCase extends PropertyConverterAbstractTestCase {
    protected PropertyConverter makePropertyConverter() {
        return new NumberConverter();
    }

    protected Conversion[] getTestConversions() {
        return new Conversion[] {
                // TODO: Should not be dependent on locale specific thousand
                // separator, fractiononal separator etc...
                new Conversion("1", new Integer(1)),
                new Conversion("-1001", new Integer(-1001), null, "-1 001".replace(' ', '\u00A0')),
                new Conversion("1E3", new Integer(1000), null, "1 000".replace(' ', '\u00A0')),

                new Conversion("-2", new Long(-2l)),
                new Conversion("2000651651854", new Long(2000651651854l), null, "2 000 651 651 854".replace(' ', '\u00A0')),
                new Conversion("2E10", new Long(20000000000l), null, "20 000 000 000".replace(' ', '\u00A0')),

                new Conversion("3", new Float(3.0)),
                new Conversion("3,1", new Float(3.1)),
                new Conversion("3,2", new Float(3.2), "#.#"),
                //new Conversion("3,3", new Float(3), "#", "3"), // Seems to need parseIntegerOnly
                new Conversion("-3,4", new Float(-3.4)),
                new Conversion("-3,5E10", new Float(-3.5e10), null, "-35 000 000 512".replace(' ', '\u00A0')),

                new Conversion("4", new Double(4)),
                new Conversion("4,1", new Double(4.1)),
                new Conversion("4,2", new Double(4.2), "#.#"),
                //new Conversion("4,3", new Double(4), "#", "4"), // Seems to need parseIntegerOnly
                new Conversion("-4,4", new Double(-4.4)),
                new Conversion("-4,5E97", new Double(-4.5e97), null, "-45000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000".replace(' ', '\u00A0')),
        };
    }
}
